
{ program to model observations }

(*
  s:='Itokawa'; { name group Amor   2004 year }
  s:='1994 GK'; { name group Apollo 2008 year }
  s:='1994 GL'; { name group Aten   2011 year }

  OneAstWithName(s,e); { UnAstReF to find with name } 
*)

program ForModelObservations ;

uses
  UnAstCoT , { types constants }
  unastrng , { global variables rangeval azimuval }
  unforprt , { for protocol text file nprt number }
  UnAstReF , { procedures OneAstWith List Name }
  UnStaCoo , { procedure PointCoor for station }
  UnForFun , { procedure MatrToScreen }
  UnRefrOl , { procedures for refraction }
  UnEphJpl , { global booopencoefile ToObtainFMuS }
  unastmob ; { for procedure SingleAstEphem }

var
  i  : integer ;  { start  year }
  j  : integer ;  { finish year }
  a  : Extended ; { start  moment in julian day }
  b  : Extended ; { finish moment in julian day }
  d  : Extended ; { step in day to print result }  
  u  : extended ; { random error semimajor axis AU }
  w  : extended ; { random error mean anomaly degree }
  k  : Integer ;  { minor planet number in list }
  n  : Integer ;  { station number }
  p  : tcoorec ;  { station position record with topo matr }
  e  : tastel ;   { set of elements for selected object }
  s  : string ;   { name or part of name of the object }

{ simple procedure
  to read in initial file astxtmob.ina
  n  number of station in text file pointcoo.txt 
  i  start  j  finish in year to prognoz
  k  number of object  in list file   atshaz.txt
  and to open protocol file with name nump+...+.txt }

procedure ProtoNum ( var  n  : integer ;   { number of station }
                     var  i  : integer ;   { start  year }
                     var  j  : integer ;   { finish year }
                     var  k  : integer ) ; { number of object  }
var
  f  : Text ;
  s  : string ;
begin
  assign(f,'astxtmob.ina'); { simple text file }
  reset(f);    { information about number of object }
  readln(f,n); { number of station }
  readln(f,i); { start  year }
  readln(f,j); { finish year }
  readln(f,k); { number in list file asthaz.txt }
                      { range and azimuth value for model }
  readln(f,rangeval); { global unastrng range value in AU }
  readln(f,azimuval); { global unastrng azimuth in degree }
  readln(f);   { random error in arcsec }
  readln(f,u); { random error for semimajor axis AU }
  readln(f,w); { random error for mean anomaly degree }
  close(f);    { only one number is necessary }
  Str(k:4,s);  { integer to string }
  if  s[1] = ' '  then  s[1]:='0'; { to fill }
  if  s[2] = ' '  then  s[2]:='0'; { blank by nullos }
  if  s[3] = ' '  then  s[3]:='0'; { if it is needed }
  s:='nump'+s+'.txt'; { name of protocol file }
  ToOpenPrt(s); { unforprt text file for protocol }
end;

begin

  Randomize ;        { for random error with Gauss }
                     { four numbers  from  astxtmob.ina }
  ProtoNum(n,i,j,k); { station start finish year object }

  { n  number of stat in text file pointcoo.txt }
  PointCoor(n,p); { result to record p UnStaCoo }

  with  p  do     { information to screen }
    begin
      writeln(nums:20,'  number of station');
      writeln(name:20,'  name of station');
      writeln(desc[1]:20:6,'  x position in km');
      writeln(desc[2]:20:6,'  y position in km');
      writeln(desc[3]:20:6,'  z position in km');
      writeln(geod[1]:20:9,'  latitude  in degree');
      writeln(geod[2]:20:9,'  longitude in degree');
      writeln(geod[3]:20:6,'  height in km');
    end;

  a:=jd2000+365.25*(i-2000.0); { const UnAstCoT for start }
  b:=jd2000+365.25*(j-2000.0); { finish moment from start }

                       { to find by number in list }
  OneAstWithList(k,e); { UnAstReF in file asthaz.txt }

  u:=WithGaussValue(0.0,u); { error semimajor axis AU }
  w:=WithGaussValue(0.0,w); { error mean anomaly degree }

  with  e  do     { information to screen }
    begin
      writeln ;
      writeln(snm,'  may be the number');
      writeln(stn,'  may be the name');
      writeln(epo:20:5,'  epoch of the elements');
      writeln(ela:20:9,'  semimajor axis in AU  ',u:20:9,'  error');
      writeln(ele:20:9,'  eccentricity');
      writeln(eli:20:7,'  angle of inclination in degree');
      writeln(eln:20:7,'  the ascending node in degree');
      writeln(elp:20:7,'  the argument of perihelium');
      writeln(elm:20:7,'  mean anomaly in degree',w:20:9,'  error');
      writeln(prh:20:2,'  parameter H');
      writeln(prg:20:2,'  parameter G');
      writeln ;
    end;

  e.ela:=e.ela+u;                { with error }
  e.elm:=e.elm+w;                { with error }

  { refraction for topocentric horizont }

  SimpleDataForRefraction ; { UnRefrOl }

  { before to call planets ephemeris procedures }

  ToObtainFMuS ;         { factor \mu for planets UnEphJpl }
  booopencoefile:=False; { file with coefficients approxim }

  writeln;
  write('        Date            RA(2000)    Decl(2000)');
  write('    range   azim.   alt.  mag. v');
  writeln;
  write('   Y  M  D  h  m  s      h  m  s      o  ''  " ');
  write('       AU     o      o      m ');
  writeln;
  writeln;

  d:=60.0/1440.0; { step in day to print result }

  d:=1.0;

  SingleAstEphem(2,a,b,d,e,p); { unastmob 0 for simple ephemeris }

  close(fprt); { unforprt protocol text file }

end.
