program ToTryGaussMethod ;
uses
  unastcot , { for types }
  unstacoo , { for pointcoor }
  unforprt , { for protocol file toopenprt }
  unephjpl , { for ephemeris }
  unreagau , { for procedure unoveclipt }
  unreapnt , { to  find number of day }
  unastrng , { for procedure osunsvector }
  unstrdat , { function togetstrfordate }
  untreran , { for procedure trerange }
  untrerel , { for procedure elemfromtwopos }
  unrecomp ; { for procedure tocomparepoints }
var
  ns  : integer ;  { number of station }
  nt  : integer ;  { count iteration }
  nd  : integer ;  { count for series }
  ks  : integer ;  { step inner series } 
  k1  : integer ;  { number in list of ephemeris point }
  k2  : integer ;  { number in list of ephemeris point }
  k3  : integer ;  { number in list of ephemeris point }
  sf  : string ;   { name of file with ephemeris list }
  pc  : tcoorec ;  { type unastcot for station }
  t1  : extended ; { moment for position julian day }
  t2  : extended ; { moment for position julian day }
  t3  : extended ; { moment for position julian day }
  e1  : tvect3 ;   { unit vector ecliptic heliocentric }
  e2  : tvect3 ;   { unit vector ecliptic heliocentric }
  e3  : tvect3 ;   { unit vector ecliptic heliocentric }
  d1  : extended ; { distance AU }
  d2  : extended ; { distance AU }
  d3  : extended ; { distance AU }
  s1  : tvect3 ;   { vector the Sun refer to station }
  s2  : tvect3 ;   { vector the Sun refer to station }
  s3  : tvect3 ;   { vector the Sun refer to station }
  h1  : extended ; { ratio \eta_1=S/\Delta for t_3-t_2 }
  h2  : extended ; { ratio \eta_2=S/\Delta for t_3-t_1 }
  h3  : extended ; { ratio \eta_3=S/\Delta for t_2-t_1 }
  q1  : extended ; { estimation range to object }
  q2  : extended ; { estimation range to object }
  q3  : extended ; { estimation range to object }
  r1  : tvect3 ;   { vector ecliptic heliocentric }
  r2  : tvect3 ;   { vector ecliptic heliocentric }
  r3  : tvect3 ;   { vector ecliptic heliocentric }
  el  : tastel ;   { elements }
  z1  : tastel ;   { elements for the point }
  z2  : tastel ;   { elements for the point }
  z3  : tastel ;   { elements for the point }
  bo  : boolean ;  { may be error to find elements }
  yv  : extended ; { value for random error arcsec }
  er  : array[1..3] of terand ; { for random error }

procedure numstat ( var  n  : integer ;    { for station number }
                    var  s  : string  ;    { file ephemeris nam }
                    var  y  : extended ) ; { random error value }
var              { from file astxtmog.ina }
  f  : text ;    { simple file to read }
  k  : integer ; { for number in list }
  a  : string ;  { for the name of protocol file fprt }
begin
  assign(f,'astxtmob.ina'); { simple text file }
  reset(f);    { to open to read }
  readln(f,n); { to read number of station }
  readln(f);   { without start  year }
  readln(f);   { without finish year }
  readln(f,k); { to read number in list asthax.txt }
  readln(f);   { without range   value to model }
  readln(f);   { without azimuth value to model }
  readln(f,y); { to read random error }
  close(f);    { that is all for read }
  Str(k:4,s);  { integer to string }
  if  s[1] = ' '  then  s[1]:='0'; { to fill }
  if  s[2] = ' '  then  s[2]:='0'; { blank by nullos }
  if  s[3] = ' '  then  s[3]:='0'; { if it is needed }
  a:='modp'+s+'.txt';       { name of protocol  file }
  toopenprt(a);        { unforprt fprt protocol file }
  s:='nump'+s+'.txt';       { name of ephemeris file }
                          { to find number of series }
  tofindseries(s);      { unreapnt with name of file }
                        { global numday numdaz [1..] }
end;

{ to find three numbers to read
  glonbal array numdaz from unreapnt }
procedure ForNumPoints ( nd  : integer ; { numb series }
                         ks  : integer ; { step series }
                         var k1 , k2 , k3  : integer ) ;
begin
  k1:=numdaz[nd,1]; { the first  element in series }
  k2:=k1+ks;        { the second element in series }
  k3:=k2+ks;        { the third  element in series }
end;

begin

  Randomize; { for random errors value }

  { before to call planets ephemeris procedures }
  ToObtainFMuS ;           { factor \mu for planets UnEphJpl }
  booopencoefile:=False;   { file with coefficients approxim }

 { procedure numstat to read astxtmog.ina
   for station number in file pointcoo.txt
   and to find number of series numday numdaz[..] }
  numstat(ns,sf,yv); { station number name text file }
                     { yv random error in arc second }
  PointCoor(ns,pc);  { result to record p UnStaCoo }

  nd:=0;    { initial number for series }

repeat      { series by series }

  nd:=nd+1; { the next number for series }

  ks:=1;    { initial step inner series }

  ForNumPoints(nd,ks,k1,k2,k3); { three numbers }

repeat      { with step inner series yv in arcsec }
            { to read r.a. decl with random error }
  unoveclipt(k1,sf,yv,t1,d1,e1,z1,er[1]); { unreagau }
  unoveclipt(k2,sf,yv,t2,d2,e2,z2,er[2]); { unreagau }
  unoveclipt(k3,sf,yv,t3,d3,e3,z3,er[3]); { unreagau }

  osunsvector(t1,pc,s1);   { unastrng the Sun fixed ecliptic }
  osunsvector(t2,pc,s2);   { unastrng the Sun fixed ecliptic }
  osunsvector(t3,pc,s3);   { unastrng the Sun fixed ecliptic }

  nt:=0;   { initial nullo iteration }

  h1:=1.0; { initital \eta_1 ratio }
  h2:=1.0; { initital \eta_2 ratio }
  h3:=1.0; { initital \eta_3 ratio }

  q1:=0.0; { initial nullo range }
  q2:=0.0; { initial nullo range }
  q3:=0.0; { initial nullo range }

  trerange(t1,t2,t3,e1,e2,e3,s1,s2,s3,h1,h2,h3,q1,q2,q3); { untreran }
  trevecto(e1,e2,e3,s1,s2,s3,q1,q2,q3,r1,r2,r3); { untreran helioecl }

repeat
  h1:=togeteta(t2,t3,q2,q3,r2,r3); { untreran for \eta_1 }
  h2:=togeteta(t1,t3,q1,q3,r1,r3); { untreran for \eta_2 }
  h3:=togeteta(t1,t2,q1,q2,r1,r2); { untreran for \eta_3 }
  trerange(t1,t2,t3,e1,e2,e3,s1,s2,s3,h1,h2,h3,q1,q2,q3); { untreran }
  trevecto(e1,e2,e3,s1,s2,s3,q1,q2,q3,r1,r2,r3); { untreran helioecl }
  nt:=nt+1;
until  nt = 5 ;

  { two moments value  \eta_2 two vectors result elements }
  elemfromtwopos(t1,t3,q1,h2,r1,r3,el,bo) ; { untrerel moment t1 }
                                                { bo true or false }
  writeln;
  writeln(ToGetStrForDate(3,z1.epo));           { unstrdat }
  writeln(z1.ela:12:6,z1.ele:12:6,z1.eli:12:6,
          z1.eln:12:6,z1.elp:12:6,z1.elm:12:6);
  writeln(k1:4,' ':10,er[1].eras:5:1,er[1].erds:5:1,er[1].alti:8:2);
  writeln(k2:4,' ':10,er[2].eras:5:1,er[2].erds:5:1,er[2].alti:8:2);
  writeln(k3:4,' ':10,er[3].eras:5:1,er[3].erds:5:1,er[3].alti:8:2);
  writeln(fprt);
  writeln(fprt,ToGetStrForDate(3,z1.epo));           { unstrdat }
  writeln(fprt,z1.ela:12:6,z1.ele:12:6,z1.eli:12:6,
               z1.eln:12:6,z1.elp:12:6,z1.elm:12:6);
  writeln(fprt,k1:4,' ':10,er[1].eras:5:1,er[1].erds:5:1,er[1].alti:8:2);
  writeln(fprt,k2:4,' ':10,er[2].eras:5:1,er[2].erds:5:1,er[2].alti:8:2);
  writeln(fprt,k3:4,' ':10,er[3].eras:5:1,er[3].erds:5:1,er[3].alti:8:2);
  if  bo    { no error it is eleemnts }
    then    { to find set of elements }
      begin { there is one set of elements }
        writeln(' ':24,d1:12:6,d2:12:6,d3:12:6);
        writeln(nd:4,k1:8,k2:6,k3:6,q1-d1:12:6,q2-d2:12:6,q3-d3:12:6);
        writeln(ToGetStrForDate(3,el.epo));     { unstrdat }
        writeln(el.ela-z1.ela:12:6,
                el.ele-z1.ele:12:6,
                el.eli-z1.eli:12:6,
                el.eln-z1.eln:12:6,
                el.elp-z1.elp:12:6,
                el.elm-z1.elm:12:6);
        writeln(fprt,' ':24,d1:12:6,d2:12:6,d3:12:6);
        writeln(fprt,nd:4,k1:8,k2:6,k3:6,q1-d1:12:6,q2-d2:12:6,q3-d3:12:6);
        writeln(fprt,ToGetStrForDate(3,el.epo));     { unstrdat }
        writeln(fprt,el.ela-z1.ela:12:6,
                     el.ele-z1.ele:12:6,
                     el.eli-z1.eli:12:6,
                     el.eln-z1.eln:12:6,
                     el.elp-z1.elp:12:6,
                     el.elm-z1.elm:12:6);
        tocomparepoints(pc,el,sf); { unrecomp to read model file }
        if  nprt = 0
          then       { no point to print }
            begin
              writeln('residuals are too large');
              writeln(fprt,'residuals are too large');
            end
          else
            begin
              writeln('there are',nprt:6,' normal value');
              writeln(fprt,'there are',nprt:6,' normal value');
            end;
      end
    else
      begin
        writeln(' ':24,d1:12:6,d2:12:6,d3:12:6);
        writeln(nd:4,k1:8,k2:6,k3:6,q1-d1:12:6,q2-d2:12:6,q3-d3:12:6);
        writeln('no set of elements');
        writeln(fprt,' ':24,d1:12:6,d2:12:6,d3:12:6);
        writeln(fprt,nd:4,k1:8,k2:6,k3:6,q1-d1:12:6,q2-d2:12:6,q3-d3:12:6);
        writeln(fprt,'no set of elements');
      end;

  ks:=ks+1; { the next step inner series }
  ForNumPoints(nd,ks,k1,k2,k3); { three numbers }

until  ( k3 > numdaz[nd,2] ) ; { number for the next series }

until  nd = numday ; { the end for series }

  close(fprt); { unforprt protocol file }

end.
