
unit UnAstVam ; { for object magnitude }

interface

uses
  unastcot ; { type record tastel tvect3 }

(* magnitude of the minor planet
   p minor planet vector from the Sun
   r minor planet vector from the Earth *)
                                { vectors in AU }
function togetmau ( e  : tastel ;
                    p , r  : tvect3 ) : extended ;

implementation

uses
  unforfun ; { functions datan2 log10 }

(* magnitude of the minor planet
   p minor planet vector from the Sun
   r minor planet vector from the Earth *)
                                { vectors in AU }
function togetmau ( e  : tastel ;
                    p , r  : tvect3 ) : extended ;
var
  x,z  : extended ;
  g,h  : extended ;
  s,t  : extended ;
  a,b  : extended ;
  c,y  : extended ;
  u,w  : extended ;
begin
  h:=e.prh; (* record e type tastel from unastcot *)
  g:=e.prg; (* record e type tastel from uuastcot *)
  togetmau:=h;                            { all vectors in AU }
  x:=Sqrt(sqr(p[1])+sqr(p[2])+sqr(p[3])); (* distance from the Sun RoP*)
  z:=Sqrt(sqr(r[1])+sqr(r[2])+sqr(r[3])); (* distance from the Earth Ro *)
  a:=(p[1]*r[1]+p[2]*r[2]+p[3]*r[3])/(x*z); (* for phase cos *)
  b:=sqrt(1-sqr(a)); (* for phase sin *)
  s:=0.5*datan2(b,a); (* half of phase *)
  t:=sin(s)/cos(s);
  a:=3.33;
  b:=0.63;
  c:=Exp(b*Ln(t));
  u:=Exp(-a*c);  (* f1 *)
  a:=1.87;
  b:=1.22;
  c:=Exp(b*Ln(t));
  if  c > 30.0  then  exit ;
  w:=Exp(-a*c);  (* f2 *)
  y:=u+g*(-u+w);
  togetmau:=h+5*Log10(z*x)-2.5*Log10(y);
end;

end.
