
 { the forces due to planets, the Moon, the Sun
   the right hand side of differential equations }

 UNIT unequras ;

 INTERFACE

 Uses
   unastcot ; { const types }

 Procedure PlanetsForces ( TEph  : Extended ;
                           CurP  : tvect3 ;
                           Var  ForceC  : tvect3 ) ;

 Procedure ClcRightHandCoor ( ut   : Extended ;
                              rc   : TVect3 ;
                              Var
                                force  : TVect3 ) ;

 IMPLEMENTATION

 uses
   unephjpl , { to use planetary ephemeris ClcPosVel for example }
   unfortim ; { procedures TransUTCtoTDT TransTDTtoTDB }

 { in CurP
   the position of the asteroid
   in the fixed equatorial system }

 Procedure PlanetsForces ( TEph  : Extended ; { moment in julian day }
                           CurP  : tvect3 ;   { equatorial position }
                           Var  ForceC  : tvect3 ) ; { forces }
 Var
   i  : Byte ;
   n  : Integer ;
   dr,sr  : Extended ;
   posp,velp  : Array [1..11] of tvect3 ;
   posa  : tvect3 ; { urct }
 Begin
   { the planets , the Sun and the Moon in J2000 system }
   For n:=1 To 11 Do
     If  ( ( n <> NEarth ) AND ( n <> NMoon ) )
       Then { refer to the barycentre }
         ClcPosVel(n,teph,posp[n],velp[n]) { for the planets }
       Else
         If  n = NEarth
           Then { refer to the barycentre }
             ClcEphEarthMoon(teph,posp[NEarth],velp[NEarth],
                                  posp[NMoon],velp[NMoon]);
   If  NOT BooExistPos
     Then { no ephemeris for this date }
       Exit ;
   dr:=1.0/Sqrt(Sqr(CurP[1])+Sqr(CurP[2])+Sqr(CurP[3])); { range }
   dr:=-FactorMuZ[NSun]*dr*dr*dr; { minor planet refer to the Sun }
   for i:=1 to 3 do        { main forces due to the Sun }
     ForceC[i]:=CurP[i]*dr; { the Sun main forces }
   For n:=1 To NumberOfPlanets Do { for all objects }
     if  n <> NSun                { but for the Sun forward }
       then
         Begin
           for i:=1 to 3 do       { position of the planet }
             posa[i]:=posp[n][i]-posp[NSun][i]; { refer to the Sun }
             dr:=1/Sqrt(+Sqr(posa[1]-CurP[1])   { for current planet }
                        +Sqr(posa[2]-CurP[2])   { and the minor planet }
                        +Sqr(posa[3]-CurP[3])); { 1/delta in km }
             dr:=dr*dr*dr; { 1/delta**3 }
             sr:=1/Sqrt(Sqr(posa[1])+Sqr(posa[2])+Sqr(posa[3])); { 1/r }
             sr:=sr*sr*sr; { 1/r**3 }
             For i:=1 To 3 Do
             ForceC[i]:=+ForceC[i]
                        +FactorMuZ[n]*(+(posa[i]-CurP[i])*dr-posa[i]*sr);
         End;
 End;

 { to calculate the Forces due to all planets }

 Procedure ClcRightHandCoor ( ut   : Extended ;   { time moment julian day }
                              rc   : TVect3 ;     { heliocentric equator }
                              Var                 { from all planets }
                                force  : TVect3 ) ; { our forces }
 Var
   td,dt,tb  : Extended ; { terrestrial time TT barycentric time TDB }
 Begin

   TransUTCtoTDT(ut,td,dt); { unit unfortim terrestrial time TT }
   TransTDTtoTDB(td,tb);    { barycentric time TDB Teph for ephemeris }
                               { the forces }
   PlanetsForces(tb,rc,force); { due to the Sun the Moon and the planets }

 End;

 END.
