 UNIT UnForCoo ; { simple procedure to change coordinate systems }

 INTERFACE

 Uses
   UnAstCoT ; { for type TMatr33 TVect3  const JD2000 JulianC }

 Procedure DescFromSpherCoor ( Azt , Alt , Ro    : Extended ;
                               Var  PosDescart  : TVect3 ) ;

 Procedure ClcTopCoorInDegree ( Pos : TVect3 ;
                                Var Azt , Alt, Ro : Extended );

 Procedure SpheriCoorInDegree ( poscart : TVect3 ;
                                Var alpha , delta, range  : Extended );

 IMPLEMENTATION

 Uses
   UnForFun , { function ATanDegree }
   UnRefrOl ; { function ToGetRefraction }

 Procedure DescFromSpherCoor ( Azt , Alt , Ro    : Extended ;
                               Var  PosDescart  : TVect3 ) ;
 Var
   cb  : Extended ;
 Begin
   cb:=Cos(Alt);
   PosDescart[1]:=Ro*Cos(Azt)*cb;
   PosDescart[2]:=Ro*Sin(Azt)*cb;
   PosDescart[3]:=Ro*Sin(Alt);
 End;

 { ClcTopCoorInDegree is a procedure in horizon system
   to obtain the topocentric coordinates in spherical form
      with refraction correction }

 Procedure ClcTopCoorInDegree ( Pos : TVect3 ; { in horizon system }
                                Var Azt , Alt, Ro : Extended );
 Var
   r,rr,q,qq,p,f,s,c,a,b : Extended;
   zr  : Extended ;
 Begin
   qq:=Sqr(Pos[1])+Sqr(Pos[2]);
   rr:=qq+Sqr(Pos[3]);
   r:=Sqrt(rr);
   q:=Sqrt(qq);
   p:=1/q;
   f:=1/r;
   c:=-p*Pos[1]; { for geodetic azimuth special direction }
   s:=+p*Pos[2];
   Azt:=ATanDegree(s,c); { UnForFun }
   c:=q*f;
   s:=Pos[3]*f;
   Alt:=RadGra*DATan2(s,c); { altitude from horizon in degree }
   Ro:=r;
   zr:=ToGetRefraction(Alt); { from UnRefrOl }
   Alt:=Alt+zr;              { to add refraction }
 End;

 Procedure SpheriCoorInDegree ( poscart : TVect3 ;
                                Var alpha , delta, range  : Extended );
 Var
   r,rr,q,qq,p,f,s,c  : Extended;
 Begin
   qq:=Sqr(poscart[1])+Sqr(poscart[2]);
   rr:=qq+Sqr(poscart[3]);
   r:=Sqrt(rr);
   q:=Sqrt(qq);
   p:=1/q;
   f:=1/r;
   c:=p*poscart[1];
   s:=p*poscart[2];
   alpha:=ATanDegree(s,c); { UnForFun }
   c:=q*f;
   s:=poscart[3]*f;
   delta:=RadGra*DATan2(s,c); { UnConTyp UnForFun }
   range:=r;
 End;

 END. { unit UnForCoo }
