
unit UnForDay ; { to find day twilight or night }

interface

uses
  unastcot ; { type tcoorec tvect3 }

function CharDayOrNight ( tc  : Extended ;  pc  : tcoorec ) : Char ;

implementation

uses
  unastrng , { procedure OstatVector for the Sun }
  unforcoo ; { procedure ClcTopCoorInDegree with refraction }

{ D for day T for TwiLight N for Night }

function CharDayOrNight ( tc  : Extended ;  pc  : tcoorec ) : Char ;
var
  xs  : tvect3 ;   { the Sun helocentric nullo }
  xz  : tvect3 ;   { the Sun topocentric equator }
  xh  : tvect3 ;   { the Sun topocentric horizon }
  az  : Extended ; { azimuth  from the north to ost in degree }
  ah  : Extended ; { altitude from horizon in degree }
  ro  : Extended ; { range from the station }
  ch  : Char ;     { character for result }
begin
  xs[1]:=0.0; { the Sun helocentric nullo x coor }
  xs[2]:=0.0; { the Sun helocentric nullo y coor }
  xs[3]:=0.0; { the Sun helocentric nullo z coor }
  { vector xh topocentric horizontal for the Sun }
  OstatVector(tc,xs,pc,xz,xh); { unastrng the Sun to topohori }
  ClcTopCoorInDegree(xh,az,ah,ro); { UnForCoo }
  { ah degree is altitude the Sun refer to horizon }
  if  ah < -18.0                   { too lower horizon }
    then  ch:='N'      { night }
    else
      if  ah < 0.0                 { lower horizon }
        then  ch:='T'  { twilight }
        else  ch:='D'; { day default }
  CharDayOrNight:=ch;  { result function }
end;

end.