unit unposfer ;
interface
uses
  unastcot ; { types }
procedure ToGetSpherPos ( tc  : extended ;        { current moment }
                          pc  : tcoorec ;         { for station }
                          el  : tastel ;          { set of elements }
                          var  ya  : extended ;   { right ascension }
                          var  yd  : extended ;   { declination }
                          var  yo  : extended ) ; { range AU }
implementation
uses
  unforcoo , { procedure SpheriCoorInDegree }
  unforfun , { function vectormodul }
  unforkep , { function fromaxistomot }
  unforequ , { procedure toequars }
  unastrng ; { procedures ostatvector ostatvequat }
{ to obtain
  topocentric spherical coordinates
  by using only simple kepler orbit }
procedure ToGetSpherPos ( tc  : extended ;        { current moment }
                          pc  : tcoorec ;         { for station }
                          el  : tastel ;          { set of elements }
                          var  ya  : extended ;   { right ascension }
                          var  yd  : extended ;   { declination }
                          var  yo  : extended ) ; { range AU }
var
  tz  : extended ; { moment with delay }
  qq  : extended ; { range from station to object in AU }
  rq  : tvect3 ;   { fixed equator position }
  vq  : tvect3 ;   { fixed equator velosity }
  xp  : tvect3 ;   { vector topocentric terrestrial }
  xh  : tvect3 ;   { vector topocentric horizontal }
  ec  : tastel ;   { set of elements for current moment }
begin
  ec:=el; { set of elements for current moment }
  tz:=tc; { initial without delay }
  { the mean anomaly in degree  for our moment }
  ec.elm:=el.elm                                    { M degree }
         +radgra*fromaxistomot(el.ela)*(tz-el.epo); { unforkep }
  toequars(ec,rq,vq); { to fixed equa helios position unforequ }
  ostatvector(tc,rq,pc,xp,xh); { unastrng topocentric position }
  qq:=vectormodul(xp);         { unforfun range station-object }
  tz:=tc-0.005776*qq;  { our moment with delay }
  { the mean anomaly in degree  for our moment }
  ec.elm:=el.elm                                    { M degree }
         +radgra*fromaxistomot(el.ela)*(tz-el.epo); { unforkep }
  toequars(ec,rq,vq); { to fixed equa helios position unforequ }
  ostatvector(tc,rq,pc,xp,xh); { unastrng topocentric position }
  ostatvequat(tc,xp,rq);       { unastrng topoc fixed  equator }
  sphericoorindegree(rq,ya,yd,yo); { unforcoo spheric  equator }
end;
end.
