unit unrecomp ; { to compare after method }
interface
uses
  unastcot ; { type tvect3 tastel }
procedure ToComparePoints ( pc  : tcoorec ;
                            el  : tastel ; 
                            sf  : string ) ;
implementation
uses
  unposfer , { procedure togetspherpos }
  unfordat , {  function  fromdatetojd }
  unforprt ; { protocol file fprt nprt }
{ type unastcot
  input
  pc for station
  el new set of elements
  sf name of file with model to compare }
procedure ToComparePoints ( pc  : tcoorec ;
                            el  : tastel ;
                            sf  : string ) ;
var
  nr  : integer ;  { count for read }
  fr  : text ;     { file with observations }
  ny  : integer ;  { year }
  nm  : integer ;  { month }
  nd  : integer ;  { day }
  kh  : integer ;  { hour }
  km  : integer ;  { minute }
  ts  : extended ; { second }
  ih  : integer ;  { R.A. hour }
  im  : integer ;  { R.A. minute }
  az  : extended ; { R.A. second }
  md  : integer ;  { decl degree }
  mm  : integer ;  { decl minute }
  ds  : extended ; { decl second }
  tc  : extended ; { current mom }
  ra  : extended ; { r.a. radian }
  rd  : extended ; { decl radian }
  ro  : extended ; { distance AU }
  ya  : extended ; { r.a. compar }
  yd  : extended ; { decl compar }
  yo  : extended ; { r.AU compar }
  qa  : extended ; { d.ra degree }
  qd  : extended ; { d.de degree }
begin
  assign(fr,sf); { file with simple test }
  reset(fr);     { to open to read }
  nr:=0;         { initial nullo point to read }
  nprt:=0;       { initial nullo point to print }
repeat
  readln(fr);                   { nullo string }
  readln(fr,ny,nm,nd,kh,km,ts); { year month day hour min sec }
  readln(fr,ih,im,az,md,mm,ds,  { right ascension declination }
            ro);                { distance AU }
  readln(fr);                   { azimuth altitude distance }
  readln(fr); { date moment with delay }
  readln(fr); { kepler elements a e i }
  readln(fr); { kepler elements O o M }
  nr:=nr+1;
  tc:=fromdatetojd(nd,nm,ny,kh,km,ts); { julian day unfordat }
  ra:=15.0*grarad*(abs(ih)+(im+az/60.0)/60.0); { r.a. radian }
  if  ih < 0  then  ra:=-ra; { may be negative value r.a. }
  rd:=grarad*(abs(md)+(mm+ds/60.0)/60.0);      { decl radian }
  if  md < 0  then  rd:=-rd; { may be negative value decl }
  { moment tc in julian day
    right ascension ra in radian
        declination rd in radian for compare }
  ToGetSpherPos(tc,pc,el,ya,yd,yo); { unposfer }
  qa:=ya-radgra*ra; { to compare result r.a. unastcot }
  qd:=yd-radgra*rd; { to compare result decl unastcot }
  if  ( abs(qa) < 2.0 )      { to limit in degree }
       and ( abs(qd) < 2.0 ) { by using residuals }
    then                     { result for printed }
      begin
        nprt:=nprt+1; { the next point int nprt file fprt from unforprt }
        writeln(fprt,nr:4,ny:8,nm:3,nd:3,kh:3,km:3, { to compare values }
                     qa:12:3,qd:12:3,yo-ro:12:6);   { to print residual }
      end;
until  eof(fr) ; { to find end of file }
  close(fr);     { to close our file }
end;
end.
